@#define T = 80
@#define TshadowI = 20

var y gAs lS r log_1PmuP log_1Pmu jP a aN log_Fw FLR i;

@#for index in 0:( TshadowI - 1 )
	varexo epsilon_shadowI_@{index};
	var LAG0_shadowI_@{index};
	@#for offset in 1:index
		var LAG@{offset}_shadowI_@{index};
	@#endfor
	@#define offset = 10000000000
@#endfor
@#define index = 10000000000

@#define logexovars = [ "Z", "Phi", "Theta", "GN", "LI" ]

@#for logexovar in logexovars
	varexo epsilon_@{logexovar};
	var log_@{logexovar};
	parameters mu_@{logexovar} sigma_@{logexovar};
	mu_@{logexovar} = 1;
	sigma_@{logexovar} = 0.1;
@#endfor
@#define logexovar = "none"

@#for lag in 0:( T - 1 )
	var LAG_@{lag}_xiPgAPzetaTgAs;
@#endfor
@#define lag = 10000000000

@#for lag in 0:T
	var LAG_@{lag}_gI;
@#endfor
@#define lag = 10000000000

@#for offset in 1:( T - 1 )
	var log_FrakturIPart_@{offset};
@#endfor
@#define offset = 10000000000
	
parameters nu beta gamma eta script_p zeta lambda;

beta = 0.99;
nu = 2;
lambda = 5.646965634867457887779456099391322297847861701252815127709856919302064392661481081041338926748410690;
eta = 0.06114349344118513700;
gamma = 2.89624039570461720000;
script_p = 0.1318583470817021400e-1;
zeta = .45463331959776981000;
mu_LI = 2124.90259002430590000000;
mu_GN = 1.003116408090966387031815077419494608290159610621548082231612265016559419056737374410934152663716980;

model; //( use_dll );
	@#for index in 0:( TshadowI - 1 )
		LAG0_shadowI_@{index} = epsilon_shadowI_@{index};
		@#for offset in 1:index
			LAG@{offset}_shadowI_@{index}(0) = LAG@{offset-1}_shadowI_@{index}(-1);
		@#endfor
		@#define offset = 10000000000
	@#endfor
	@#define index = 10000000000
	
	#shadowI_price = 0
		@#for index in 0:( TshadowI - 1 )
			+ LAG@{index}_shadowI_@{index}(0)
		@#endfor
		@#define index = 10000000000
	;

	@#for logexovar in logexovars
		#LAG_log_@{logexovar}	= log_@{logexovar}(-1);
		log_@{logexovar} 		= log( mu_@{logexovar} ) + sigma_@{logexovar} * ( epsilon_@{logexovar} );
		#LEAD_log_@{logexovar} 	= log_@{logexovar}(+1);
		#LAG_@{logexovar} 		= exp( LAG_log_@{logexovar} );
		#@{logexovar} 			= exp( log_@{logexovar} );
		#LEAD_@{logexovar} 		= exp( LEAD_log_@{logexovar} );
	@#endfor
	@#define logexovar = "none"

	@#for offset in 1:( T - 1 )
		#LAG_FrakturIPart_@{offset} = exp( log_FrakturIPart_@{offset}(-1) );
		#FrakturIPart_@{offset} = exp( log_FrakturIPart_@{offset}(0) );
		#LEAD_FrakturIPart_@{offset} = exp( log_FrakturIPart_@{offset}(+1) );
	@#endfor
	@#define offset = 10000000000

	#LAG_c 		= y(-1);
	#c 			= y(0);
	#LEAD_c 	= y(+1);
	#LAG_C 		= exp( y(-1) );
	#C 			= exp( y(0) );
	#LEAD_C 	= exp( y(+1) );
	#LAG_Y 		= exp( y(-1) );
	#Y 			= exp( y(0) );
	#LEAD_Y 	= exp( y(+1) );

	#LAG_I 		= exp( i(-1) );
	#I 			= exp( i(0) );
	#LEAD_I 	= exp( i(+1) );
	
	#LAG_gAs 	= gAs(-1);
	#LEAD_gAs 	= gAs(+1);
	#LAG_GAs 	= exp( gAs(-1) );
	#GAs 		= exp( gAs(0) );
	#LEAD_GAs 	= exp( gAs(+1) );
	
	#LAG_mu 	= exp( log_1Pmu(-1) ) - 1;
	#mu 		= exp( log_1Pmu(0) ) - 1;
	#LEAD_mu 	= exp( log_1Pmu(+1) ) - 1;
	#LAG_muP 	= exp( log_1PmuP(-1) ) - 1;
	#muP 		= exp( log_1PmuP(0) ) - 1;
	#LEAD_muP 	= exp( log_1PmuP(+1) ) - 1;
	
	#LAG_JP 	= exp( jP(-1) );
	#JP 		= exp( jP(0) );
	#LEAD_JP 	= exp( jP(+1) );
	#JPM1		= exp( jP(0) ) - 1;

	#LAG_A 		= exp( a(-1) );
	#A 			= exp( a(0) );
	#LEAD_A 	= exp( a(+1) );
	#LAG_AN 	= exp( aN(-1) );
	#AN 		= exp( aN(0) );
	#LEAD_AN 	= exp( aN(+1) );

	#LAG_Fw 	= exp( log_Fw(-1) );
	#Fw 		= exp( log_Fw(0) );
	#LEAD_Fw 	= exp( log_Fw(+1) );
	
	#GA			= A / LAG_A * GAs;
	#LEAD_GA	= LEAD_A / A * LEAD_GAs;

	#gI 		= LAG_0_gI;
	#GI			= exp( gI );
	
	#R			= exp( r );
	#LS			= exp( lS );
	
	#LEAD_XiTGY	= LEAD_Theta / Theta * LEAD_GN / GN;

	#w			= -log_1Pmu(-1);																																		// wage 
	#W			= exp( w );
	#FrakturIPart_0 = script_p / ( 1 - script_p ) * LI * W * exp( -shadowI_price );																						// inventor entry

	@#for lag in 1:T
		LAG_@{lag}_gI(0) = LAG_@{lag-1}_gI(-1);
	@#endfor
	@#define lag = 10000000000
	#LAG_@{T+1}_gI = LAG_@{T}_gI(-1);
	
	log_Fw = 0
	@#for lag in 0:( T - 1 )
		- LAG_@{lag}_gI
	@#endfor
	@#define lag = 10000000000
	;
	
	LAG_0_xiPgAPzetaTgAs = log_Theta + LAG_c - LAG_log_Theta - c + zeta * gAs;
	@#for lag in 1:( T - 1 )
		LAG_@{lag}_xiPgAPzetaTgAs(0) = LAG_@{lag-1}_xiPgAPzetaTgAs(-1);
	@#endfor
	@#define lag = 10000000000
	
	@#for offset in 0:( T - 1 )
		log( FrakturIPart_@{offset} ) = log( 1
			@#for lag in 0:( offset - 1 )
				* beta * exp( LAG_@{lag}_xiPgAPzetaTgAs )
			@#endfor
			@#define lag = 10000000000
		* FLR * W * JP
			@#if offset < ( T - 1 )
				+ LEAD_FrakturIPart_@{offset+1}
			@#endif
		);
	@#endfor
	@#define offset = 10000000000
	
	#shadowLR = 0;
	
	gI = log_GN + i - i(-1) - zeta * gAs;																																// invention growth
	log_Phi + nu * lS(0) = w - c(0);																																	// labour supply
	beta * R * C / LEAD_C * LEAD_Theta / Theta / LEAD_GA = 1;																											// euler

	-1 / lambda * log_1Pmu(0) = log( exp( -1 / lambda * log_1PmuP ) * ( 1 - Fw ) + ( 1 + eta * lambda ) ^ ( -1 / lambda ) * Fw );										// mark-up aggregation
	1 / lambda * ( a - log_1Pmu(-1) ) = log( exp( -1 / lambda * log_1PmuP(-1) ) * ( 1 - LAG_Fw ) + ( AN / ( 1 + eta * lambda ) ) ^ ( 1 / lambda ) * LAG_Fw );			// productivity aggregation
	1 / lambda * aN = log( ( 1 / GAs ) ^ ( 1 / lambda ) * ( 1 - exp( -LAG_@{T+1}_gI ) ) + ( LAG_AN / GAs ) ^ ( 1 / lambda ) * exp( -LAG_@{T+1}_gI ) );					// productivity of non-protected firms
	
	log_1PmuP = log( lambda * eta * JPM1 + ( 1 + lambda ) * eta + JPM1 ) - log( JPM1 + eta );																			// strategic pricing
	1 / script_p / muP * LEAD_XiTGY * LEAD_A ^ ( -1 / lambda ) * LEAD_Z * FLR / ( 1 + gamma * LEAD_Z * FLR ) = ( 1 - shadowLR ) * LEAD_XiTGY * LEAD_A ^ ( -1 / lambda );// research decision
	gAs = ( 1 / gamma ) * log( 1 + gamma * Z * FLR(-1) );																												// research pay-off
	beta / I / JP * muP / ( 1 + muP ) * ( ( 1 + mu ) / ( 1 + muP ) ) ^ ( 1 / lambda ) * LEAD_XiTGY * LEAD_A ^ ( -1 / lambda ) = 1 / script_p * FLR * W / Y;				// firm free entry

	lS = log( LI * I * ( 1 - 1 / GI )
	+ I * ( 1 - Fw ) * JP * FLR
	+ Y * (
		( 1 / A ) ^ ( 1 / lambda ) * ( ( 1 + mu ) / ( 1 + muP ) ) ^ ( ( 1 + lambda ) / lambda ) * ( 1 - LAG_Fw )
		+ ( AN / A ) ^ ( 1 / lambda ) * ( ( 1 + mu ) / ( 1 + eta * lambda ) ) ^ ( ( 1 + lambda ) / lambda ) * LAG_Fw
	) );																																								// labour market clearing
end;

write_latex_dynamic_model;

initval;
	@#for logexovar in logexovars
		log_@{logexovar} = log( mu_@{logexovar} );
		epsilon_@{logexovar} = 0;
	@#endfor
	@#define logexovar = "none"

	@#for index in 0:( TshadowI - 1 )
		epsilon_shadowI_@{index} = 0;
		LAG0_shadowI_@{index} = 0;
		@#for offset in 1:index
			LAG@{offset}_shadowI_@{index} = 0;
		@#endfor
		@#define offset = 10000000000
	@#endfor
	@#define index = 10000000000
	
	y			= -.1219700640929673213321963915446396618193872885048425049621254167781259827957007204849319186274043028;
	gAs 		= 0.004625640326497175975617593019945575427460629113888299758553407626772549994175261841092414060251647236;
	lS 			= -0.8740602799581604894554905835005636227303075381054145194699546370894997394640567208338206672180620780e-1;
	r 			= 0.01467597617999861715916645057849328151297563678851817313725283315635555899842557549080060660934927482;
	log_1Pmu	= 0.2967821200845994192232945082447523863654487961259254088561163441960259306885120646516960520710167183;
	log_1PmuP	= 0.2989664341659373145177900533179914376453512517343722070859081220446622221154036943960918353237360242;
	jP			= 4.630687615788276990583131721271460410143591809496267123967900222648591240036312389468913124030546641;
	a			= -3.014593015962151222788170193907850750179299291790235600892240943052804419123786466322909497613647339;
	aN			= -3.359542398543627953153999686062396393464591695644690688713292263771437850162122678148168608395769752;
	log_Fw		= -0.8068735517600056823834846096555333054868300884088993900899906751895727889170335346051662660923720479e-1;
	FLR			= 0.004656763932438071322994114461215250480678949060577740737189957002252846995368120228867207704725970990;
	i			= -4.244833118715690820659262999385986644691219131935841757315537461823212904371073405612234603555531722;

	@#for lag in 0:( T - 1 )
		LAG_@{lag}_xiPgAPzetaTgAs = 0.002102970216900722897020644237930583368141462389488875762387511656013034013853708081743542167384534903;
	@#endfor
	@#define lag = 10000000000

	@#for lag in 0:T
		LAG_@{lag}_gI = 0.001008591939700007102979355762069416631858537610511124237612488343986965986146291918256457832615464821;
	@#endfor
	@#define lag = 10000000000

	@#for TMPoffset in 1:( T - 1 )
		@#define offset = T - TMPoffset
		log_FrakturIPart_@{offset} = log
		(
			0.9920841311795447674140091270000453211284422460327333394423783196817471028973202724228617997478579284 ^ @{offset} * 0.3550385117912112662285333095355105855289065798908240283269414733559250563703251525105015906891902623
			@#if offset < ( T - 1 )
				+ exp( log_FrakturIPart_@{offset+1} )
			@#endif
		);
	@#endfor
	@#define TMPoffset = 10000000000
	@#define offset = 10000000000
end;

shocks;
	@#for logexovar in logexovars
		var epsilon_@{logexovar} = 1;
	@#endfor
	@#define logexovar = "none"
	
	@#for index in 0:( TshadowI - 1 )
		var epsilon_shadowI_@{index} = 1;
	@#endfor
	@#define index = 10000000000
end;

// check( solve_algo = 0 );

stoch_simul( solve_algo = 0, periods = 0, order = 1, irf = 200, nograph, noprint, replic = 1, pruning ) y gAs lS r log_1Pmu log_1PmuP jP a aN log_Fw FLR i LAG_0_gI // nocorr, nofunctions, nomoments, 
@#for logexovar in logexovars
	log_@{logexovar}
@#endfor
@#define logexovar = "none"
;