function RetVal = jmpToMin( x )
    global nu
    zeta = x( 1 );
	n = x( 2 );
    g = x( 3 );
    p = x( 4 );
    LI = x( 5 );
    l = 1 / n / g;
    d = 0;
    if p*g>1/l
        RetVal = NaN;
        return
    end
    if fsolve( @(JP)( jmpJPEquation( JP, zeta, n, g, p, LI ) ), 1, optimset( 'Display', 'off' ) ) > 1
        RetVal = NaN;
        return
    end
    JP = fsolve( @(JP)( jmpJPEquation( JP, zeta, n, g, p, LI ) ), 4, optimset( 'Display', 'off' ) );
    [GI,Fw,mP,LR,GA,mAgg,AN,A,W,YOverII,LSTIIP1Onu] = jmpGetValues1( JP, zeta, n, g, p, LI );
    if Fw <= 0 || Fw >= 1
        RetVal = NaN;
        return;
    end
    II = (LSTIIP1Onu/(LI*(1-(1-d)/GI)+(1-Fw)*JP*LR+YOverII*((1/A)^(1/l)*((1+mAgg)/(1+mP))^((1+l)/l)*(1-Fw)+(AN/A)^(1/l)*((1+mAgg)/(1+n*l))^((1+l)/l)*Fw)))^(nu/(1+nu));
    Y = YOverII * II;
    % GIConstraint1 = GI-1.0025;
    % GIConstraint2 = 1.00025-GI;
    markupConstraint1 = mAgg-0.355;
    markupConstraint2 = 0.345-mAgg;
    GAConstraint1 = (100*GA-100)-0.465;
    GAConstraint2 = 0.455-(100*GA-100);
    RSConstraint1 = (100*(LI*II*(1-(1-d)/GI)+II*(1-Fw)*JP*LR)*W/Y)-2.65;
    RSConstraint2 = 2.55-(100*(LI*II*(1-(1-d)/GI)+II*(1-Fw)*JP*LR)*W/Y);
    Ineqs = [ markupConstraint1, markupConstraint2, GAConstraint1, GAConstraint2, RSConstraint1, RSConstraint2 ]; % GIConstraint1, GIConstraint2, 
    RetVal =  ( mAgg-mP ) * 0 - 100 * ( GI - 1 );
    if max( Ineqs ) > 0
        % RetVal = NaN;
        RetVal = RetVal + 100000 * norm( Ineqs );
    end
    if ~isreal( [GI,Fw,mP,LR,GA,mAgg,AN,A,W,YOverII,LSTIIP1Onu] ) || ~isreal( Ineqs )
        RetVal = NaN;
    end
end