@#define T = 80
@#define TshadowI = 20

var y gAs lS r log_1PmuP log_1Pmu jP a aN log_Fw FLR i;

@#for index in 0:( TshadowI - 1 )
	varexo epsilon_shadowI_@{index};
	var LAG0_shadowI_@{index};
	@#for offset in 1:index
		var LAG@{offset}_shadowI_@{index};
	@#endfor
	@#define offset = 10000000000
@#endfor
@#define index = 10000000000

@#define logexovars = [ "Z", "Phi", "Theta", "GN", "LI" ]

@#for logexovar in logexovars
	varexo epsilon_@{logexovar};
	var log_@{logexovar};
	parameters mu_@{logexovar} sigma_@{logexovar};
	mu_@{logexovar} = 1;
	sigma_@{logexovar} = 0.1;
@#endfor
@#define logexovar = "none"

@#for lag in 0:( T - 1 )
	var LAG_@{lag}_xiPgAPzetaTgAs;
@#endfor
@#define lag = 10000000000

@#for lag in 0:T
	var LAG_@{lag}_gI;
@#endfor
@#define lag = 10000000000

@#for offset in 1:( T - 1 )
	var log_FrakturIPart_@{offset};
@#endfor
@#define offset = 10000000000
	
parameters nu beta gamma eta script_p zeta lambda;

beta = 0.99;
nu = 2;
lambda = 1.241794781923343635931861243120947814317929868398221134315670540526510943752327850181016887208151653;
eta = 0.07636615823729164800;
gamma = 10.54506415711971500000;
script_p = 0.4529089249695308200e-1;
zeta = 0;
mu_LI = 160.96113386560174000000;
mu_GN = 1.003116408090966387031815077419494608290159610621548082231612265016559419056737374410934152663716980;

model; //( use_dll );
	@#for index in 0:( TshadowI - 1 )
		LAG0_shadowI_@{index} = epsilon_shadowI_@{index};
		@#for offset in 1:index
			LAG@{offset}_shadowI_@{index}(0) = LAG@{offset-1}_shadowI_@{index}(-1);
		@#endfor
		@#define offset = 10000000000
	@#endfor
	@#define index = 10000000000
	
	#shadowI_price = 0
		@#for index in 0:( TshadowI - 1 )
			+ LAG@{index}_shadowI_@{index}(0)
		@#endfor
		@#define index = 10000000000
	;

	@#for logexovar in logexovars
		#LAG_log_@{logexovar}	= log_@{logexovar}(-1);
		log_@{logexovar} 		= log( mu_@{logexovar} ) + sigma_@{logexovar} * ( epsilon_@{logexovar} );
		#LEAD_log_@{logexovar} 	= log_@{logexovar}(+1);
		#LAG_@{logexovar} 		= exp( LAG_log_@{logexovar} );
		#@{logexovar} 			= exp( log_@{logexovar} );
		#LEAD_@{logexovar} 		= exp( LEAD_log_@{logexovar} );
	@#endfor
	@#define logexovar = "none"

	@#for offset in 1:( T - 1 )
		#LAG_FrakturIPart_@{offset} = exp( log_FrakturIPart_@{offset}(-1) );
		#FrakturIPart_@{offset} = exp( log_FrakturIPart_@{offset}(0) );
		#LEAD_FrakturIPart_@{offset} = exp( log_FrakturIPart_@{offset}(+1) );
	@#endfor
	@#define offset = 10000000000

	#LAG_c 		= y(-1);
	#c 			= y(0);
	#LEAD_c 	= y(+1);
	#LAG_C 		= exp( y(-1) );
	#C 			= exp( y(0) );
	#LEAD_C 	= exp( y(+1) );
	#LAG_Y 		= exp( y(-1) );
	#Y 			= exp( y(0) );
	#LEAD_Y 	= exp( y(+1) );

	#LAG_I 		= exp( i(-1) );
	#I 			= exp( i(0) );
	#LEAD_I 	= exp( i(+1) );
	
	#LAG_gAs 	= gAs(-1);
	#LEAD_gAs 	= gAs(+1);
	#LAG_GAs 	= exp( gAs(-1) );
	#GAs 		= exp( gAs(0) );
	#LEAD_GAs 	= exp( gAs(+1) );
	
	#LAG_mu 	= exp( log_1Pmu(-1) ) - 1;
	#mu 		= exp( log_1Pmu(0) ) - 1;
	#LEAD_mu 	= exp( log_1Pmu(+1) ) - 1;
	#LAG_muP 	= exp( log_1PmuP(-1) ) - 1;
	#muP 		= exp( log_1PmuP(0) ) - 1;
	#LEAD_muP 	= exp( log_1PmuP(+1) ) - 1;
	
	#LAG_JP 	= exp( jP(-1) );
	#JP 		= exp( jP(0) );
	#LEAD_JP 	= exp( jP(+1) );
	#JPM1		= exp( jP(0) ) - 1;

	#LAG_A 		= exp( a(-1) );
	#A 			= exp( a(0) );
	#LEAD_A 	= exp( a(+1) );
	#LAG_AN 	= exp( aN(-1) );
	#AN 		= exp( aN(0) );
	#LEAD_AN 	= exp( aN(+1) );

	#LAG_Fw 	= exp( log_Fw(-1) );
	#Fw 		= exp( log_Fw(0) );
	#LEAD_Fw 	= exp( log_Fw(+1) );
	
	#GA			= A / LAG_A * GAs;
	#LEAD_GA	= LEAD_A / A * LEAD_GAs;

	#gI 		= LAG_0_gI;
	#GI			= exp( gI );
	
	#R			= exp( r );
	#LS			= exp( lS );
	
	#LEAD_XiTGY	= LEAD_Theta / Theta * LEAD_GN / GN;

	#w			= -log_1Pmu(-1);																																		// wage 
	#W			= exp( w );
	#FrakturIPart_0 = script_p / ( 1 - script_p ) * LI * W * exp( -shadowI_price );																						// inventor entry

	@#for lag in 1:T
		LAG_@{lag}_gI(0) = LAG_@{lag-1}_gI(-1);
	@#endfor
	@#define lag = 10000000000
	#LAG_@{T+1}_gI = LAG_@{T}_gI(-1);
	
	log_Fw = 0
	@#for lag in 0:( T - 1 )
		- LAG_@{lag}_gI
	@#endfor
	@#define lag = 10000000000
	;
	
	LAG_0_xiPgAPzetaTgAs = log_Theta + LAG_c - LAG_log_Theta - c + zeta * gAs;
	@#for lag in 1:( T - 1 )
		LAG_@{lag}_xiPgAPzetaTgAs(0) = LAG_@{lag-1}_xiPgAPzetaTgAs(-1);
	@#endfor
	@#define lag = 10000000000
	
	@#for offset in 0:( T - 1 )
		log( FrakturIPart_@{offset} ) = log( 1
			@#for lag in 0:( offset - 1 )
				* beta * exp( LAG_@{lag}_xiPgAPzetaTgAs )
			@#endfor
			@#define lag = 10000000000
		* FLR * W * JP
			@#if offset < ( T - 1 )
				+ LEAD_FrakturIPart_@{offset+1}
			@#endif
		);
	@#endfor
	@#define offset = 10000000000
	
	#shadowLR = 0;
	
	gI = log_GN + i - i(-1) - zeta * gAs;																																// invention growth
	log_Phi + nu * lS(0) = w - c(0);																																	// labour supply
	beta * R * C / LEAD_C * LEAD_Theta / Theta / LEAD_GA = 1;																											// euler

	-1 / lambda * log_1Pmu(0) = log( exp( -1 / lambda * log_1PmuP ) * ( 1 - Fw ) + ( 1 + eta * lambda ) ^ ( -1 / lambda ) * Fw );										// mark-up aggregation
	1 / lambda * ( a - log_1Pmu(-1) ) = log( exp( -1 / lambda * log_1PmuP(-1) ) * ( 1 - LAG_Fw ) + ( AN / ( 1 + eta * lambda ) ) ^ ( 1 / lambda ) * LAG_Fw );			// productivity aggregation
	1 / lambda * aN = log( ( 1 / GAs ) ^ ( 1 / lambda ) * ( 1 - exp( -LAG_@{T+1}_gI ) ) + ( LAG_AN / GAs ) ^ ( 1 / lambda ) * exp( -LAG_@{T+1}_gI ) );					// productivity of non-protected firms
	
	log_1PmuP = log( lambda * eta * JPM1 + ( 1 + lambda ) * eta + JPM1 ) - log( JPM1 + eta );																			// strategic pricing
	1 / script_p / muP * LEAD_XiTGY * LEAD_A ^ ( -1 / lambda ) * LEAD_Z * FLR / ( 1 + gamma * LEAD_Z * FLR ) = ( 1 - shadowLR ) * LEAD_XiTGY * LEAD_A ^ ( -1 / lambda );// research decision
	gAs = ( 1 / gamma ) * log( 1 + gamma * Z * FLR(-1) );																												// research pay-off
	beta / I / JP * muP / ( 1 + muP ) * ( ( 1 + mu ) / ( 1 + muP ) ) ^ ( 1 / lambda ) * LEAD_XiTGY * LEAD_A ^ ( -1 / lambda ) = 1 / script_p * FLR * W / Y;				// firm free entry

	lS = log( LI * I * ( 1 - 1 / GI )
	+ I * ( 1 - Fw ) * JP * FLR
	+ Y * (
		( 1 / A ) ^ ( 1 / lambda ) * ( ( 1 + mu ) / ( 1 + muP ) ) ^ ( ( 1 + lambda ) / lambda ) * ( 1 - LAG_Fw )
		+ ( AN / A ) ^ ( 1 / lambda ) * ( ( 1 + mu ) / ( 1 + eta * lambda ) ) ^ ( ( 1 + lambda ) / lambda ) * LAG_Fw
	) );																																								// labour market clearing
end;

write_latex_dynamic_model;

initval;
	@#for logexovar in logexovars
		log_@{logexovar} = log( mu_@{logexovar} );
		epsilon_@{logexovar} = 0;
	@#endfor
	@#define logexovar = "none"

	@#for index in 0:( TshadowI - 1 )
		epsilon_shadowI_@{index} = 0;
		LAG0_shadowI_@{index} = 0;
		@#for offset in 1:index
			LAG@{offset}_shadowI_@{index} = 0;
		@#endfor
		@#define offset = 10000000000
	@#endfor
	@#define index = 10000000000
	
	y			= -0.4919410445304434157952815109331036225103989187841986161208214847472941804232811815050640261410705983e-1;
	gAs 		= 0.004539680042031828679922926361954989356593079122280527387839332860116538480175340016469477328856725665;
	lS 			= -0.2100838780017074776706201379619978014915130452365117396371731243336631832526302063610962776302453847e-1;
	r 			= 0.01459001589553326986347178392050269544210808679691040076653875838969954748442565366617766987795435302;
	log_1Pmu	= 0.09121088005338583711365217868570992254934250092572220953951677334146205469285415942272565814015613700;
	log_1PmuP	= 0.09337422624211840904307954910534299686188782266586867030402174560968461544657999283860359605940368186;
	jP			= 3.391903529014088093700360551048198077795112991479078390172069107660370910025646282571932091034393262;
	a			= -.6807899447368186763274837981034132332993674651399593732363761674145557951023560880185810034367905449;
	aN			= -.9671186213132040227577053322072305294584437300482971097559468811035938735393078650465932790587398925;
	log_Fw		= -.2489249725280584000000000000000000000000000000000000000000000000000000000000000000000000000000000049;
	FLR			= 0.004650094893666615238673004178848894027484645115566605093223318361416234387928462698290636292931550120;
	i			= -2.954694007948647282956777646273300290098159409254303913118881716419765070221048691501538788285290036;

	@#for lag in 0:( T - 1 )
		LAG_@{lag}_xiPgAPzetaTgAs = 0;
	@#endfor
	@#define lag = 10000000000

	@#for lag in 0:T
		LAG_@{lag}_gI = 0.003111562156600730000000000000000000000000000000000000000000000000000000000000000000000000000000000062;
	@#endfor
	@#define lag = 10000000000

	@#for TMPoffset in 1:( T - 1 )
		@#define offset = T - TMPoffset
		log_FrakturIPart_@{offset} = log
		(
			beta ^ @{offset} * 0.1261637006976193854924936923702698833005003431819259055002703421883218368483240574507782496018721265
			@#if offset < ( T - 1 )
				+ exp( log_FrakturIPart_@{offset+1} )
			@#endif
		);
	@#endfor
	@#define TMPoffset = 10000000000
	@#define offset = 10000000000
end;

shocks;
	@#for logexovar in logexovars
		var epsilon_@{logexovar} = 1;
	@#endfor
	@#define logexovar = "none"
	
	@#for index in 0:( TshadowI - 1 )
		var epsilon_shadowI_@{index} = 1;
	@#endfor
	@#define index = 10000000000
end;

// check( solve_algo = 0 );

stoch_simul( solve_algo = 0, periods = 0, order = 1, irf = 200, nograph, noprint, replic = 1, pruning ) y gAs lS r log_1Pmu log_1PmuP jP a aN log_Fw FLR i LAG_0_gI // nocorr, nofunctions, nomoments, 
@#for logexovar in logexovars
	log_@{logexovar}
@#endfor
@#define logexovar = "none"
;